//---------------------------------------------------------------------------

#include <vcl.h>
#include <IniFiles.hpp>
#pragma hdrstop

#include "Krata.h"
#include "TState.h"
#include "TPoly.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmKrata *frmKrata;
//---------------------------------------------------------------------------
__fastcall TfrmKrata::TfrmKrata(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TfrmKrata::FormShow(TObject *Sender)
{
        TIniFile *ini;
        ini = new TIniFile( ChangeFileExt( Application->ExeName, ".INI" ) );

        int rzad = ini->ReadInteger("Model", "rzad", 2);
        int poly_count = ini->ReadInteger("Model", "poly_count", 2);
        AnsiString *p = new AnsiString[poly_count];                      // ile wielomianow

        // inicjacja wielomianw
        for(int i=0;i<poly_count;i++)
                p[i] = ini->ReadString("w"+IntToStr(i), "item", "1");

        int states_count = (int)pow(2,rzad);
        TState *s = new TState[states_count];
        TPoly *polys = new TPoly[poly_count];
        for(int i=0;i<poly_count;i++)
        {
                polys[i].SetRank(rzad);
                polys[i].SetPoly(p[i]);
        }


        //int t_step = 360/states_count;
        int t_step = 60;
        int top=20, left=30;
        int step = 20;

        frmKrata->Height = 2*top+t_step*states_count;
        frmKrata->Width = 270;
        
        img->Align = alNone;
        img->Height = 2*top+t_step*states_count;
        img->Width = 270;
        img->Align = alClient;
        frmKrata->Refresh();



        TRect rec(0,0,img->Width, img->Height);
        img->Canvas->Brush->Color = clCream;
        img->Canvas->FillRect(rec);

        img->Canvas->Font->Name = "Verdana";
        img->Canvas->Font->Size = 10;
        img->Canvas->Refresh();

        /*
        AnsiString txt;
        for(int i=0;i<states_count;i++)
        {
                s[i].Init(i, rzad);
                top = step + i*t_step;
                for(int j=0;j<2;j++)
                {
                        AnsiString input = IntToStr(j) + s[i].GetState();
                        img->Canvas->MoveTo(left, top);
                        int c = s[i].Next(j);
                        img->Canvas->LineTo(left + 200, step+c*t_step);
                        if(j==0) img->Canvas->TextOutA(left, top-15, input);
                        if(j==1) img->Canvas->TextOutA(left, top+15, input);

                }
        }
        */

        for(int i=0;i<states_count;i++)
        {
                s[i].Init(i,rzad);
                top = step + i*t_step;
                AnsiString txt;
                for(int j=0;j<2;j++)
                {
                        AnsiString input = "";
                        AnsiString output = "";
                        input = IntToStr(j) + s[i].GetState();          // obliczenie sekwencji wejsciowej
                        for(int k=0;k<poly_count;k++)
                                output = output + polys[k].CalcOutput(input);


                        int c = s[i].Next(j);
                        if(j==0)
                        {
                                img->Canvas->Pen->Color = clBlue;
                                img->Canvas->Pen->Style = psSolid;
                        }
                        if(j==1)
                        {
                                img->Canvas->Pen->Color = clRed;
                                img->Canvas->Pen->Style = psDot;
                        }
                        img->Canvas->Font->Color = clGreen;
                        img->Canvas->Font->Style = TFontStyles()<< fsBold;

                        img->Canvas->MoveTo(left, top);
                        img->Canvas->LineTo(left + 200, step+c*t_step);
                        txt = s[i].GetState();
                        int off_y = img->Canvas->TextHeight(txt)/2;
                        img->Canvas->TextOutA(left-25-3, top-off_y, s[i].GetState());

                        txt = s[i].TransStr(j);
                        off_y = img->Canvas->TextHeight(txt)/2;
                        img->Canvas->TextOutA(left+200+3, step+c*t_step-off_y, s[i].TransStr(j));


                        txt = output;
                        off_y = img->Canvas->TextHeight(txt)/2;
                        if(j==0)
                        {
                                img->Canvas->Font->Color = clBlue;
                                img->Canvas->TextOutA(left+15, top-20, txt);
                        }
                        if(j==1)
                        {
                                img->Canvas->Font->Color = clRed;
                                img->Canvas->TextOutA(left+15, top+5, txt);
                        }
                        //img->Canvas->TextOutA(left-15+(j*40), step+c*t_step-off_y+15, txt);
                        //if(j==1) img->Canvas->TextOutA(left-15, step+c*t_step-off_y-15, txt);


                }
        }

}
//---------------------------------------------------------------------------

