#include <math.h>

class TPoly
{
        AnsiString g;                           // string z wielomianem
        int rzad;                               // ogolny rzad systemu
        bool *bits;                             // pokazuje ktore pola ze stanu i wejsca sa brane

        void Decode(void);                      // dekoduje string na postac logiczna
   public:

        void SetPoly(AnsiString p) { g = p; Decode(); }
        void SetRank(int r) { rzad = r; }
        int CalcOutput(AnsiString in);


};

//------------------------------------------------------------------------------

int TPoly::CalcOutput(AnsiString in)
{
        int suma = 0;
        for(int i=1;i<=in.Length();i++)
        {
                int v = StrToInt(in.SubString(i,1));
                if(bits[i-1]) suma+= v;
        }
        return fmod(double(suma), 2.0);
}

void TPoly::Decode(void)
{
        /*
         * szukaj wszystkich x, policz je, sprawdz ile jest cyfr, sprawdz czy jest jedynka i pojedynczy x
         */
        bits = new bool[rzad+1];               // przechowuje aktywne pola dla danego wyjscia g()
        for(int i=0;i<rzad+1;i++) bits[i] = false;

        int pos = -1;
        int ile_x = 0;
        AnsiString tmp = g;
        while(pos!=0)   // liczy wszystkie x w wielomianie
        {
                pos = tmp.Pos("x");
                if(pos!=0)
                {
                        ile_x++;
                        tmp = tmp.SubString(pos+1, tmp.Length());
                }
        }

        int count=0;
        tmp = g;
        for(int i=1;i<=rzad+1;i++)      // sprawdza jakie cyfry wystepuja w wielomianie
        {
                pos = tmp.Pos(IntToStr(i));
                if(pos!=0)
                {
                        if(i==1) bits[0] = true;   // specjalne traktowanie "jedynki"s
                        else
                        {
                                bits[i] = true;
                                count++;
                        }
                }
        }
        if(count!=ile_x) bits[1] = true;   // jesli ilosc x i ilosc cyfr przy x sie nie zgadza to mamy "goly" x

        //int pos = g.Pos("1");
        /*
        AnsiString msg = "";
        for(int i=0;i<rzad+1;i++)
        {
                if(bits[i]) msg += " [1] ";
                else msg += " [0] ";
        }
        ShowMessage(msg);
        */
}
