#include <math.h>

class TState
{
        AnsiString state_str;                                   // numer stanu w postaci bitowej jako string
        int id;                                                 // numer stanu
        int rzad;                                               // rzad systemu

        int states_count;                                       // ilosc stanow w systemie
        int min_id;                                             // indeks stanu, ktory mial najmniejszy koszt przejscia (odczyt po wywolaniu GetDist())

        int acc_dist;                                           // zakumulowany dystans dla danego stanu                                              
        int *metric;                                            // metryka dla kadego z poprzedzajacych stanw jako metryka poprzedniego stanu plus koszt przejscia
        int **last_best;

        void DecodeToStr(void);

   public:
        void Init(int n, int rank);
        void ClearMetric(void);
        AnsiString TransStr(int v);
        int Next(int v);
        int TransCost(AnsiString str1, AnsiString str2);
        void SetMetric(int id, int cost) { metric[id] = cost; }
        int CalcDist(int cost) { return acc_dist+cost; }

        void SetRank(int r) { rzad = r; }
        AnsiString GetState(void) { return state_str; }
        void ComputeDist(void);
        int GetAccDist(void) { return acc_dist; }
        int GetMin(void) { return min_id; }
};

//------------------------------------------------------------------------------

void TState::ComputeDist(void)
{
        int min = -1;

        for(int i=0;i<states_count;i++)
        {
                if(metric[i]!=-1)
                {
                        if(min==-1)
                        {
                                min = metric[i];
                                min_id = i;
                        }
                        else
                        {
                                if(metric[i]<min)
                                {
                                        min = metric[i];
                                        min_id = i;
                                }
                        }

                }
        }
        if(min!=-1)
        {
                acc_dist = metric[min_id];// + metric[min_id];
                //min_id = 0;
        }
        else
        {
                min_id = -1;
                acc_dist = 0;                        
                //ShowMessage("Ta wiadomo nie powinna si pokaza!");
        }
        return;
}

int TState::TransCost(AnsiString str1, AnsiString str2)
{
        int count = 0;
        for(int i=1;i<=str1.Length();i++)
        {
                if(str1.SubString(i,1)!=str2.SubString(i,1))
                        count++;
        }
        return count;
}

int TState::Next(int v)
{
        AnsiString to = state_str.SubString(1,rzad-1);
        to = IntToStr(v) + to;

        int sum = 0;

        for(int i=1;i<=to.Length();i++)
        {
                if(to.SubString(i,1)=="1") sum += pow(2.0, rzad-i);
        }
        return sum;
}

AnsiString TState::TransStr(int v)
{
        AnsiString to = state_str.SubString(1,rzad-1);
        to = IntToStr(v) + to;
        return to;
}

void TState::Init(int n, int rank)
{
        id = n;
        rzad = rank;
        acc_dist = 0;
        states_count = pow(2.0, rank);
        metric = new int[states_count];
        ClearMetric();
        DecodeToStr();
}

void TState::ClearMetric(void)
{
        for(int i=0;i<states_count;i++)
                metric[i] = -1;
}


void TState::DecodeToStr(void)
{
        int val = id;
        state_str = "";
        for(int i=rzad-1;i>=0;i--)
        {
                int x = pow(2.0,i);
                if(val>=x)
                {
                        state_str += "1";
                        val -= x;
                }
                else state_str += "0";
        }
}
 